version: '3'

services:
  app:
    build: .
    ports:
      - "5000:5000"
    depends_on:
      - postgres
    links:
      - postgres
    environment:
      FLASK_APP: app.py
      FLASK_ENV: development
      POSTGRES_HOST: postgres
      POSTGRES_DB: mydatabase
      POSTGRES_USER: myuser
      POSTGRES_PASSWORD: mypassword
    volumes:
      - mydatabase_data:/var/lib/postgresql/data
    networks:
      - mynetwork
  postgres:
    image: postgres
    environment:
      POSTGRES_DB: mydatabase
      POSTGRES_USER: myuser
      POSTGRES_PASSWORD: mypassword
    volumes:
      - mydatabase_data:/var/lib/postgresql/data
    networks:
      - mynetwork

volumes:
  mydatabase_data:screen-scraping


networks:
  mynetwork:

  flask:
    environment:
      FLASK_DEBUG: 1
      FLASK_APP: ./app.py
    build:
      context: .
      dockerfile: Dockerfile
    volumes:
      - ./:/app
    container_name: flask
    ports:
      - '5000:5000'

  db:
    image: postgres:13-alpine
    volumes:
      - postgres_data:/var/lib/postgresql/data/
      - ./postgres_scripts:/var/postgres_scripts/
    environment:
      - POSTGRES_USER=mock_dev_user
      - POSTGRES_PASSWORD=mock_dev_pass
      - POSTGRES_DB=postgres_dev

  selenium-hub:
    image: selenium/hub
    ports:
      - "4444:4444"
    environment:
      GRID_MAX_SESSION: 16
      GRID_BROWSER_TIMEOUT: 300
      GRID_TIMEOUT: 300

  chrome:
    image: selenium/node-chrome
    depends_on:
      - selenium-hub
    environment:
      HUB_PORT_4444_TCP_ADDR: selenium-hub
      HUB_PORT_4444_TCP_PORT: 4444
      NODE_MAX_SESSION: 2
      NODE_MAX_INSTANCES: 2

  firefox:
    image: selenium/node-firefox
    depends_on:
      - selenium-hub
    environment:
      HUB_PORT_4444_TCP_ADDR: selenium-hub
      HUB_PORT_4444_TCP_PORT: 4444
      NODE_MAX_SESSION: 4
      NODE_MAX_INSTANCES: 4